
package audio;

public class AudioMessageThread extends Thread {
	protected int windowsID;	// our threadID so that we can call GetMessage()

	protected AudioMessageThread() {}

	public void run() {
		Audio dev;
		AudioBlock b;
		windowsID = getThreadIDN();
		AudioMessage msg = new AudioMessage();
		Audio.println(" +++ Message Thread Started (id = " + windowsID + ") +++ ");

		synchronized(this) {
			this.notifyAll();	// notify everyone who is waiting for us to start
		}

		while(true) try {
			msg.message = 0;
			msg.param1 = msg.param2 = 0;
			getMessageN(msg);
			switch(msg.message) {
			case msg.WOM_OPEN:
				Audio.println("Device out opened ("+msg.param1+","+msg.param2+")");
				break;
			case msg.WOM_CLOSE:
				Audio.println("Device out closed ("+msg.param1+","+msg.param2+")");
				break;
			case msg.WOM_DONE:
				Audio.println("Device done ("+msg.param1+","+msg.param2+")");
				// take this off the dev.out.blocks queue to signal that it is finished.
				// also, notify both the queue and the block
				dev = Audio.getDeviceByHwo(msg.param1);
				b = (AudioBlock)dev.out.sentblocks.get();
				if (b == null || msg.param2 != b.wpHeader) {
					Audio.println(" +++ Can't find finished block!");
					break;
				}
				b.markAsFinished();
				break;
			case msg.WIM_OPEN:
				Audio.println("Device in opened ("+msg.param1+","+msg.param2+")");
				break;
			case msg.WIM_CLOSE:
				Audio.println("Device in closed ("+msg.param1+","+msg.param2+")");
				break;
			case msg.WIM_DATA:
				Audio.println("Device data ("+msg.param1+","+msg.param2+")");
				// this block came from the dev.in.sentblocks queue
				// the finished block in the dev.in.blocks queue. Notify just the queue.
				// also, send the block back to the device.
				dev = Audio.getDeviceByHwi(msg.param1);
				b = (AudioBlock)dev.in.sentblocks.get();
				if (b == null || msg.param2 != b.wpHeader) {
					Audio.println(" +++ Can't find incoming block!");
					break;
				}
				b.markAsFinished();
				break;
			default:
				Audio.println("UNKNOWN MESSAGE: " + msg.message);
			}
		} catch (ThreadDeath e) {
			return;
		} catch (Throwable e) {
			e.printStackTrace(System.out);
		}
	}
	static native int getThreadIDN();
	static native int getMessageN(AudioMessage msg);
}