package audio;

// AudioOut plays blocks to the sondcard
// first, you should call out.start(), at which point
// any blocks waiting will be played in order, one at a time
import util.Queue;

public class AudioOut {
	protected Audio dev;
	protected Queue sentblocks;

	private native void startN();
	private native void stopN();
	public void start() throws AudioException {
		startN();
		dev.checkError();
	}
	public void stop() throws AudioException {
		stopN();
		dev.checkError();
	}

	protected AudioOut(Audio dev) {
		this.dev = dev;
		sentblocks = new Queue();
	}

	public void putBlock(AudioBlock block) throws AudioException {
		Audio.println("sending block");
		if (!block.makeUseOut()) throw new AudioException("Block is already in use, can't do output");
		// add block to queue
		Audio.println("about to send");
		sentblocks.put(block);
		Audio.println("calling native");
		putBlockN(block);
		Audio.println("checking errors");
		dev.checkError();
		Audio.println("done");
	}
	
	private native void putBlockN(AudioBlock block);
	
	// flush, kill, checkbacklog, etc.
}
